> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/editing-page-content/write.md).

# Write page content to PDF on iOS

Learn how to write page content to a new document, embed elements in PDF pages, and edit page content programmatically with PDFNet. Full code samples included. The Apryse iOS SDK streamlines secure do

To write page content to a new document.

{% tabs %}
{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
PTPDFDoc *doc = [[PTPDFDoc alloc] init];

// ElementBuilder is used to build new Element objects
PTElementBuilder *builder = [[PTElementBuilder alloc] init];

// ElementWriter is used to write Elements to the page
PTElementWriter *writer = [[PTElementWriter alloc] init];	

// Start a new page
PTPage *page = [doc PageCreate: [[PTPDFRect alloc] initWithX1: 0 y1: 0 x2: 612 y2: 794]];

// begin writing to the page
[writer WriterBeginWithPage: page placement: e_ptoverlay page_coord_sys: YES compress: YES];	

// Create an Image that can be reused multiple times in the document or multiple on the same page.		
PTImage *img = [PTImage Create: [doc GetSDFDoc] filename: imagename];
PTElement *element = [builder CreateImageWithMatrix:img mtx: [[PTMatrix2D alloc] initWithA: 200 b: -145 c: 20 d: 300 h: 200 v: 150]];
[writer WritePlacedElement: element];

// use the same image (just change its matrix)
PTGState *gstate = [element GetGState];	
[gstate SetTransform: 200 b: 0 c: 0 d: 300 h: 50 v: 450];
[writer WritePlacedElement: element];

// use the same image again (just change its matrix).
[writer WritePlacedElement: [builder CreateImageWithCornerAndScale: img x: 300 y: 600 hscale: 200 vscale: -150]];

// save changes to the current page
[writer End];  

// Add the new page to the document sequence
[doc PagePushBack: page];
```

{% endcode %}
{% endtab %}

{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
let doc: PTPDFDoc = PTPDFDoc()

// ElementBuilder is used to build new Element objects
let builder: PTElementBuilder = PTElementBuilder() 

// ElementWriter is used to write Elements to the page
let writer: PTElementWriter = PTElementWriter() 

// Start a new page
var page: PTPage? = doc.pageCreate(PTPDFRect(x1: 0, y1: 0, x2: 612, y2: 794))

// begin writing to the page
writer.writerBegin(with: page, placement: e_ptoverlay, page_coord_sys: true, compress: true)    

// Create an Image that can be reused in the document or on the same page.
let img: PTImage = PTImage.create(doc.getSDFDoc(), filename: imagename)
var element = builder.createImage(withMatrix: img, mtx: PTMatrix2D(a: 300, b: -145, c: 20, d: 200, h: 200, v: 150))
writer.writePlacedElement(element)

// use the same image (just change its matrix)
var gstate = element.getGState()   
gstate.setTransform(200, b: 0, c: 0, d: 300, h: 50, v: 450)
writer.writePlacedElement(element)

// use the same image again (just change its matrix).
writer.writePlacedElement(builder.createImage(withCornerAndScale: img, x: 300, y: 600, hscale: 200, vscale: -150))

// save changes to the current page
writer.end() 

// Add the new page to the document sequence
doc.pagePushBack(page)
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Build, Write, Embed Elements in PDF Pages](/ios/get-started/samples.md#elementbuilder) Full code sample which illustrates how to use PDFNet page writing API, how to embed fonts and images and how to copy graphical elements from one page to another.

## About writing page content

New page content can be added to an existing page or a blank new page using ElementBuilder and ElementWriter. ElementBuilder is used to instantiate one or more Elements that can be written to one or more pages using ElementWriter:

![](https://4149080208-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgY6xtY9ZQd9XMpvWlGM0%2Fuploads%2Fgit-blob-ea16d96af120df93136b29c81a91c2d2e6211a7a%2F27fe7de6ec2dcabb5c4f5d64e7449afb67067285-370x328.gif?alt=media)

Note that once the Element is instantiated using ElementBuilder, you have full control over its properties and graphics state.

Page content can also come from existing pages. For example, you can use ElementReader to read paths, text, and images from existing pages and copy them to the current page. Note that, along the way, you can fully modify an Element's properties or its graphics state. This is how to perform page content editing. For example, the following copies all Elements from an existing page and changes text color to blue:

{% tabs %}
{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
PTPDFDoc *doc = [[PTPDFDoc alloc] initWithFilepath: filename];
PTPage *first_page = [doc GetPage:1];

PTElementWriter *writer = [[PTElementWriter alloc] init];
PTElementReader *reader = [[PTElementReader alloc] init];
[reader Begin: page];
[writer Begin: page placement: e_ptreplacement page_coord_sys: NO];

PTElement *element;	
while ((element = [reader Next])) 	// Read page contents
{
  switch ([element GetType])
  {		
    case e_pttext_obj:
      {
        // Set all text to blue color.
        PTGState *gs = [element GetGState];
        [gs SetFillColorSpace: [PTColorSpace CreateDeviceRGB]];
        PTColorPt *cp = [[PTColorPt alloc] initWithX: 0 y: 0 z: 1 w: 0];
        [gs SetFillColorWithColorPt: cp];
        [writer WriteElement: element];
        break;
      }
    default:
        [writer WriteElement: element];
  }
}

[writer End];
[reader End];
```

{% endcode %}
{% endtab %}

{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
let doc: PTPDFDoc = PTPDFDoc(filepath: filename)
let first_page: PTPage = doc.getPage(1)

let writer: PTElementWriter = PTElementWriter()
let reader: PTElementReader = PTElementReader()
reader.begin(page)
writer.begin(page, placement: e_ptreplacement, page_coord_sys: false)

while let element = reader.next()
{
  switch element.getType() {
    case e_pttext_obj:
        // Set all text to blue color.
        let gs: PTGState = element.getGState()
        gs.setFill(PTColorSpace.createDeviceRGB())
        let cp = PTColorPt(x: 0, y: 0, z: 1, w: 0)
        gs.setFillColor(with: cp)
        writer.write(element)
    default:
        writer.write(element)
  }
}

writer.end()
reader.end()
```

{% endcode %}
{% endtab %}
{% endtabs %}

[PDF Editor (Programmatic)](/ios/get-started/samples.md#elementedit) Full code sample which strips all images from the page and changes text color to blue.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/ios/editing-page-content/write.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
